import unittest
from unittest.mock import patch

from tmc import points, reflect
from tmc.utils import load, load_module, reload_module, get_stdout, check_source
from functools import reduce
import os
import os.path
import textwrap
import inspect, re
from random import choice, randint, shuffle

exercise = 'src.remove_smaller_than'

def source_rows(funktio: callable):
    src = inspect.getsource(funktio)
    lines = [line.strip() for line in re.split('\\n|;', src) 
        if len(line.strip()) > 0 and not line.strip().startswith("#")]
    return len(lines)

@points('1.remove_smaller_than')
class RemoveSmallerThanTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte.")]):
           cls.module = load_module(exercise, 'en')

    def test_0a_main_program_ok(self):
        ok, line = check_source(self.module)
        message = """Koden för att testa funktionerna ska placeras inuti
if __name__ == "__main__":
block. Följande rad ska flyttas:
"""
        self.assertTrue(ok, message+line)
    
    def test_1_function_exists(self):
        try:
            from src.remove_smaller_than import remove_smaller_than
        except Exception as e:
            self.fail(f'Din kod bör innehålla funktionen remove_smaller_than.')

    def test_2_type_of_return_value(self):
        try:
            from src.remove_smaller_than import remove_smaller_than
            val = remove_smaller_than([1,3],2)
        except Exception as e:
            self.assertTrue(False, f"Funktion ger fel vid:" + 
                f"\nremove_smaller_than([1,3],2):\n{e}")
        taip = str(type(val)).replace("<class '","").replace("'>","")
        self.assertTrue(type(val) == list, f"Funktionen remove_smaller_than förväntas returnera ett värde som är av typen list, nu returnerar den ett värde {val} som är av typen {taip}\n när det anropas med parametern remove_smaller_than([1,3],2)")
        

    def test_3_length_of_function(self):
        from src.remove_smaller_than import remove_smaller_than
        lines = source_rows(remove_smaller_than)
        max_lines = 2
        self.assertTrue(lines <= max_lines, f'Funktion remove_smaller_than måste ha högst {max_lines} rader i den här övningen.\nFunktionen har nu totalt {lines} rader (exklusive tomma rader och kommentarer).')

    def test_4_test_with_values_1(self):
        test_case = ([1,2,3,4,5,6,7],4)
        corr = [4,5,6,7]
        from src.remove_smaller_than import remove_smaller_than
        val = remove_smaller_than(test_case[0], test_case[1])

        self.assertEqual(val, corr, f'Funktionen förväntas returnera följande lista:\n{corr}\nnär den anropas med parametern {test_case}\nnu returnerar funktionen\n{val}')

    def test_5_test_with_values_2(self):
        test_case = ([100,101,102,105,106,103,99,98,107],105)
        corr = [105,106,107]
        from src.remove_smaller_than import remove_smaller_than
        val = remove_smaller_than(test_case[0], test_case[1])

        self.assertEqual(val, corr, f'Funktionen förväntas returnera följande lista:\n{corr}\nnär den anropas med parametern {test_case}\nnu returnerar funktionen\n{val}')

    def test_6_test_with_values_3(self):
        test_case = ([-5,-3,-10,-15,-16,-11,-12,-8],-12)
        corr = [-5,-3,-10,-11,-12,-8]
        from src.remove_smaller_than import remove_smaller_than
        val = remove_smaller_than(test_case[0], test_case[1])

        self.assertEqual(val, corr, f'Funktionen förväntas returnera följande lista:\n{corr}\nnär den anropas med parametern {test_case}\nnu returnerar funktionen\n{val}')

if __name__ == '__main__':
    unittest.main()